#!/bin/sh


. /var/log/copfilter/default/etc/global_settings
. /var/ipcop/main/settings
. /var/log/copfilter/default/langs/en.sh
. /var/log/copfilter/default/langs/${LANGUAGE}.sh

#check if AVG enabled before update databases
if [ "x$AVG_ENABLE" = "xon" ]; then

# create temporary directory 
mkdir -p ${TMPDIR}


touch /tmp/avg.log
TMPAVGLOG=/tmp/avg1.log

SENDEMAIL_OPTIONS=""
APPEND=""
WEBOUTPUT=""

if [ ! -f /var/ipcop/red/active ] ; then
   echo "no internet connection available, so no updates will be downloaded" |logger -t "antivirus update avg $APPEND"
   exit
fi

if [ "x$1" = "xweboutput" ]; then
  APPEND="<BR>"
fi



if [ -f ${BASEDIR}/etc/smtp_auth_enable ]; then
        SENDEMAIL_OPTIONS="-xu ${SMTP_AUTH_USER} -xp ${SMTP_AUTH_PASS}"
        echo "smtp authentication enabled, using user: ${SMTP_AUTH_USER}"
fi




######################################### SEARCH LAST VERSION ###########################################################

# directory for temporary files
TMPDIR=/tmp/avg-update
# create temporary directory 
mkdir -p ${TMPDIR}

wget -t 3 --no-check-certificate -O /tmp/avg-update/LASTVERSION_AVG http://shelby.eurowireless.de/AVG-mod/LASTVERSION_AVG
		if [ -s /tmp/avg-update/LASTVERSION_AVG ]
		then 
			rm -f "/var/log/copfilter/default/opt/avg/var/log/LASTVERSION_AVG" >/dev/null 2>&1
			cp /tmp/avg-update/LASTVERSION_AVG /var/log/copfilter/default/opt/avg/var/log/LASTVERSION_AVG

		fi


############  UPDATE DATABASE #####################

echo "AVG updating ..." | logger -t "antivirus update avg"


################### added ###########
echo "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= AVG =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=" >> /tmp/avg.log 2>&1
echo $APPEND >> /tmp/avg.log 2>&1
echo $CP_avg_update_mail >> /tmp/avg.log 2>&1
echo $APPEND >> /tmp/avg.log 2>&1
date >> /tmp/avg.log 2>&1
echo "AVG updating ..." >> /tmp/avg.log 2>&1
avgupdate >> /tmp/avg.log 2>&1



############### CHECK AVG VERSION ##################################################
. /var/log/copfilter/default/etc/global_settings
. /var/ipcop/main/settings

APPEND=""

echo ${APPEND}
echo "" >> /tmp/avg.log 2>&1

lastversion=""
lastversion=$(cat '/var/log/copfilter/default/opt/avg/var/log/LASTVERSION_AVG')

if [ "${LANGUAGE}" = "fr" ]; then 
	echo "La version la plus rcente de l'addon Virus Scanner est: $lastversion "
else
	if [ "${LANGUAGE}" = "de" ]; then
		echo "Neue Version des Virus Scanner mod ist: $lastversion "
	else
		echo "The latest version of Virus Scanner Mod is : $lastversion "
	fi
fi

echo "${APPEND}"

sed 's/\.//g' /var/log/copfilter/default/opt/avg/var/log/LASTVERSION_AVG >>/tmp/LASTVERSION_AVG			
echo "${AVG_MOD}">>/tmp/AVG_MOD1
sed 's/\.//g' /tmp/AVG_MOD1 >/tmp/AVG_MOD
version=$(cat '/tmp/LASTVERSION_AVG')
avgversion=$(cat '/tmp/AVG_MOD')


if [ "$avgversion" -ge "$version" ]; then 
	if [ "${LANGUAGE}" = "fr" ]; then 
		echo "La version installe de l'addon Virus Scanner est: ${AVG_MOD}."
		echo "Votre systme est  jour."
	else
		if [ "${LANGUAGE}" = "de" ]; then
			echo "Die Version ${AVG_MOD} ist installiert. "
			echo "Ihr System ist auf dem neuesten Stand. "
		else
			echo "Version ${AVG_MOD} of Virus Scanner mod is installed "
			echo "Your system is up to date. "

		fi
	fi
else
	if [ "${LANGUAGE}" = "fr" ]; then 

	################## French notification beginning #############################################
		echo "Votre version de l'addon Virus Scanner est : ${AVG_MOD} " >> /tmp/avg.log 2>&1
		echo "Votre version est OBSOLETE!  " >> /tmp/avg.log 2>&1
	################## French notification end #############################################

	else

		if [ "${LANGUAGE}" = "de" ]; then 
		################## German notification beginning #############################################
			echo "Deine Version des Virus Scanner mod ist : ${AVG_MOD} " >> /tmp/avg.log 2>&1
			echo "Deine Version des Virus Scanner mod ist VERALTET ! " >> /tmp/avg.log 2>&1
		################ German notification end #############################################
		else
			################## English notification beginning #############################################
			echo "Your version of Virus Scanner Mod is : ${AVG_MOD} " >> /tmp/avg.log 2>&1
			echo "Your version is Outdated!  " >> /tmp/avg.log 2>&1
			################# English notification end #############################################


		fi
	fi

fi

rm -f /tmp/AVG_MOD
rm -f /tmp/AVG_MOD1
rm -f /tmp/LASTVERSION_AVG
############### END OF CHECK RULES VERSION ##################################################






	########## MODIFY LOG #################################
	cat /tmp/avg.log | sed -e '/^.*s$/d' > $TMPAVGLOG
	mv -fT $TMPAVGLOG /tmp/avg.log
	cat /tmp/avg.log | sed \
	-e '/.*\%.*/d' -e '/.*\]\[2K.*/d' -e '/^\[2K.*/d' > $TMPAVGLOG
	mv -fT $TMPAVGLOG /tmp/avg.log

	grep "up-to-date" /tmp/avg.log >/dev/null 2>&1
	if [ $? != 0 ]; then
		cat /tmp/avg.log >> /var/log/copfilter/default/opt/tools/var/log/avgupd.log 2>&1
	fi






######################## UPDATE CURRENT VERSION FILE ############"
sed -n '/Version/p' /opt/avg/av/log/0/scand.pub.rollog >/tmp/CURRENTVERSION_AVG1 2>&1
sed -n '1p' /tmp/CURRENTVERSION_AVG1 >/tmp/CURRENTVERSION_AVG 2>&1

sed 's/.*\(Version.*\)/\1/' /tmp/CURRENTVERSION_AVG > $BASEDIR/opt/avg/CURRENTVERSION 2>&1
cat $BASEDIR/opt/avg/CURRENTVERSION > /tmp/CURRENTVERSION_AVG
sed 's/Version/AVG Version/g' /tmp/CURRENTVERSION_AVG > $BASEDIR/opt/avg/CURRENTVERSION 2>&1


ls -la --time-style=long-iso /opt/avg/av/var/data/ |grep incavi.avm | sed 's/  */ /g' | cut -d " " -f 6-7 >/tmp/CURRENTVERSION_AVG1 2>&1

date_incavi=`cat /tmp/CURRENTVERSION_AVG1`
echo "$date_incavi incavi.avm" >> $BASEDIR/opt/avg/CURRENTVERSION 2>&1








######################## SEND MAIL ##################
if [ "x$UPDATE_MAIL_NOTIF" = "xoff" -o "x$UPDATE_MAIL_NOTIF" = "xerror" ]; then
	 echo "no email notification will be sent, because this feature is not enabled" 
 elif [ "x$UPDATE_MAIL_NOTIF" = "xon" ]; then
 	echo "email notification will be sent, because this feature is enabled" 

	grep "up-to-date" /tmp/avg.log >/dev/null 2>&1

	if [ $? != 0 ]; then
		################## English notification beginning #############################################
		echo "Update was successfully completed "
		cat /tmp/avg.log | ${SENDEMAIL}  ${SENDEMAIL_OPTIONS} -f ${SENDER_ADR} -t ${EMAIL_ADR} -s "${SMTP_HOST}" \
	 	-u "[Copfilter] AntiVirus Update: AVG " \
		################# English notification end #############################################
	else
		
		echo "You are currently up-to-date "


	
		
	fi
fi

rm -f /tmp/avg.log
rm -f /tmp/avg1.log
rm -r /tmp/avg-update/
rm -f /tmp/CURRENTVERSION_AVG
rm -f /tmp/CURRENTVERSION_AVG1

fi

exit













################################################# OLD CONTENT - CHECK BEFORE REMOVE ########################

TMP_FILE1=$TMPDIR/avg.tmp1
TMP_FILE2=$TMPDIR/avg.tmp2
TMP_FILE3=$TMPDIR/avg.tmp3

#LD_LIBRARY_PATH=$BASEDIR/opt/avg/lib $BASEDIR/opt/avg/default/bin/avgscan >$TMP_FILE1
LD_LIBRARY_PATH=/opt/avg/av/lib /opt/avg/av/bin/avgscand >$TMP_FILE1

#LD_LIBRARY_PATH=$BASEDIR/opt/avg/lib $BASEDIR/opt/avg/default/bin/avgupdate --online -n | logger -t "avgupdate"
LD_LIBRARY_PATH=/opt/avg/av/lib /opt/avg/av/bin/avgupd --online -n | logger -t "avgupd"#

#LD_LIBRARY_PATH=$BASEDIR/opt/avg/lib $BASEDIR/opt/avg/default/bin/avgscan >$TMP_FILE2
LD_LIBRARY_PATH=/opt/avg/av/lib /opt/avg/av/bin/avgscand >$TMP_FILE2

#cp -p $TMP_FILE2 $BASEDIR/opt/avg/CURRENTVERSION

echo "" > $TMP_FILE3
echo >> $TMP_FILE3
echo $CP_avg_update_mail >>$TMP_FILE3
echo >> $TMP_FILE3
cat $TMP_FILE2 |egrep -v "Usage|help" >>$TMP_FILE3
echo >> $TMP_FILE3
echo >> $TMP_FILE3

diff $TMP_FILE1 $TMP_FILE2  >/dev/null 2>&1
if [ $? != 0 ]; then
  echo "update available:" | logger -t "antivirus update avg"
if [ "x${SMTP_HOST}" = "x" -o "x${EMAIL_ADR}" = "x" ] ; then
  echo "no email notification will be sent, since SMTP_HOST and/or EMAIL_ADR where not yet specified" | logger -t "antivirus update avg"
else
  cat $TMP_FILE2 | logger -t "copfilter antivirus update avg"
  if [ -f $BASEDIR/etc/smtp_auth_enable ]; then
      echo "smtp authentication enabled, using user: $SMTP_AUTH_USER" | logger -t "antivirus update avg"
     cat $TMP_FILE3 | $SENDEMAIL -xu $SMTP_AUTH_USER -xp $SMTP_AUTH_PASS \
                          -f $SENDER_ADR -t $EMAIL_ADR -s "${SMTP_HOST}"  \
                          -u "[Copfilter] AntiVirus Update: AVG" |logger -t "sendemail avg"
  else
      echo "not using smtp authentication" | logger -t "antivirus update avg"
      cat $TMP_FILE3 |  $SENDEMAIL -f $SENDER_ADR -t $EMAIL_ADR -s "${SMTP_HOST}"  \
                                   -u "[Copfilter] AntiVirus Update: AVG" |logger -t "sendemail avg"
  fi
fi
else
  echo "no update available" | logger -t "antivirus update avg"
fi

#rm -f $TMP_FILE1
#rm -f $TMP_FILE2
#rm -f $TMP_FILE3



exit