#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
# $Id: copfilter.cgi,v 0.00.0.3 2005/03/15 mmadlener
#

# Add entry in menu
# MENUENTRY copfilter 120 "Tests & Logs" "copfilter testlog"
#
# Make sure translation exists $Lang::tr{'copfilter testlog'}

use strict;
use IO::Socket;
# enable only the following on debugging purpose
#use warnings;
#use CGI::Carp 'fatalsToBrowser';



################################################################################
##   Definitions
################################################################################

require '/usr/lib/ipcop/general-functions.pl';
require "/usr/lib/ipcop/lang.pl";
require "/usr/lib/ipcop/header.pl";

my ($copfilter_swroot);
my %copfiltersettings=();
my %netsettings=();
my (%selected,%checked)=();
my $errormessage = '';
my $output = '';
my $sortorder = 2;
$copfiltersettings{'ACTION'} = '';

$copfilter_swroot = '/var/log/copfilter/default';
&General::readhash("${General::swroot}/ethernet/settings", \%netsettings);
&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);
#&General::writehash("/tmp/before_cgi", \%copfiltersettings);
&General::getcgihash(\%copfiltersettings);

#testing
#my %copfiltersettings2=();
#&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings3);
#&Header::getcgihash(\%copfiltersettings2);
#&General::writehash("/tmp/after_cgi", \%copfiltersettings);
#&General::writehash("/tmp/cgi", \%copfiltersettings2);


&Header::showhttpheaders();
&Header::openpage('Copfilter', 1, '');


#sub copfilter_set_lang {

package Lang;

### Initialize language
%Lang::tr = ();
    our $language;
    my %settings = ();
    &General::readhash("${General::swroot}/main/settings", \%settings);
    $language = $settings{'LANGUAGE'};
    if ($language =~ /^(\w+)$/) {$language = $1;}
    do "${copfilter_swroot}/langs/en.pl";
    do "${copfilter_swroot}/langs/${language}.pl";
1;
#}
#
#copfilter_set_lang();






################################################################################
##   Substitutions
################################################################################


sub copfilter_start_log
{

	&Header::openbigbox('100%', 'left');
	&Header::openbox('100%', 'left', "$Lang::tr{'copfilter'}:");
	print "<H1>  $Lang::tr{'copfilter log'}: </H1>\n";
}

sub copfilter_stop_log
{
        print "<br /><br />";
        #system('echo "<A HREF=$HTTP_REFERER> Back to the copfilter configuration page </A>"');
        print "<A HREF='/cgi-bin/copfilter_testlog.cgi' > $Lang::tr{'copfilter back'} </A>\n";
        print "<br /><br />";

        &Header::closebox();
        &Header::closebigbox();
        &Header::closepage();
}


sub writehashsorted
{
        my $filename = $_[0];
        my $hash = $_[1];
        my ($var, $val);


        # write cgi vars to the file.
        open(FILE, ">${filename}") or die "Unable to write file $filename";
        flock FILE, 2;
        foreach $var (sort (keys %$hash))
        {
                $val = $hash->{$var};
                # Darren Critchley Jan 17, 2003 added the following because when submitting with a graphic, the x and y
                # location of the mouse are submitted as well, this was being written to the settings file causing
                # some serious grief! This skips the variable.x and variable.y
                if (!($var =~ /(.x|.y)$/)) {
                        if ($val =~ / /) {
                                $val = "\'$val\'"; }
                        if (!($var =~ /^ACTION/)) {
                                print FILE "${var}=${val}\n"; }
                }
        }
        close FILE;
}


sub downloadver
{
        my %proxysettings=();
        &General::readhash("${General::swroot}/proxy/settings", \%proxysettings);

        my $peer = 'www.copfilter.org';
        my $peerport = 80;

        if ($_=$proxysettings{'UPSTREAM_PROXY'}) {
        ($peer, $peerport) = (/^(?:[a-zA-Z ]+\:\/\/)?(?:[A-Za-z0-9\_\.\-]*?(?:\:[A-Za-z0-9\_\.\-]*?)?\@)?([a-zA-Z0-9\.\_\-]*?)(?:\:([0-9]{1,5}))?(?:\/.*?)?$/);
        }

        my $sock=();
        unless($sock = new IO::Socket::INET (PeerAddr => $peer, PeerPort => $peerport, Proto => 'tcp', Timeout => 5))
        {
                return 0;
        }


        my $GET_CMD;
        $GET_CMD  = "GET http://www.copfilter.org/LATEST-VERSION-V2 HTTP/1.1\r\n";
        $GET_CMD .= "Host: www.copfilter.org\r\n";
        $GET_CMD .= "Cache-Control: no-cache\r\n";
        $GET_CMD .= "Connection: close\r\n\r\n";
        print $sock "$GET_CMD";

        my $ret = '';
        while (<$sock>) {
                $ret .= $_; }
        close($sock);
        return $ret;
}





################################################################################
##   ACTIONs
################################################################################


######### Send Testvirus
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter send testvirus'} )
{
        system ('/usr/local/bin/copfilter_sendtestvirus 2>&1 |logger -t "copfilter send testvirus" &');
        $copfiltersettings{'ACTION'} = '';
}


######### Send Testspam
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter send testspam'} )
{
        system ('/usr/local/bin/copfilter_sendtestspam 2>&1 |logger -t "copfilter send testspam" &');
        $copfiltersettings{'ACTION'} = '';
}


######### Send Testattachment (exe)
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter send exe attachment'} )
{
        system ('/usr/local/bin/copfilter_sendexeattachment 2>&1 |logger -t "copfilter send exe attachment" &');
        $copfiltersettings{'ACTION'} = '';
}


if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter save'})
{


################################################################################
##   Checking input values
################################################################################

	if ($copfiltersettings{'POP3_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SANITIZE_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_RED'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE_NOTIFY_USER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_NOTIFY_USER'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_VIRUS_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_SPAM_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SANITIZE_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_AUTH_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DEBUG'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DAILY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SPAM_SCAN_SPEEDUP'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'PRIVOXY_ENABLE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'MONIT_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'CLAMD_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FPROT_ENABLE'} !~ /^(on|off)$/ ) 
        {
		$errormessage = $Lang::tr{'copfilter invalid input'};
		goto ERROR;
	} 


ERROR:
	if ($errormessage) {
		$copfiltersettings{'VALID'} = 'no'; }
	else {
              	$copfiltersettings{'VALID'} = 'yes'; }



################################################################################
##   set update values
################################################################################




################################################################################
##   purge enable and update files
################################################################################



	if ($copfiltersettings{'VALID'} eq 'yes')
	{

# if setting were valid, write settings and reconfigure

         &writehashsorted("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);


        }


$copfiltersettings{'ACTION'} = '';

}






################################################################################
##  Website - Information
################################################################################


#for testing purposes only
#&General::writehash("/tmp/settings", \%copfiltersettings);

if ($copfiltersettings{'ACTION'} eq '')
{

&Header::openbigbox('100%', 'left', '', $errormessage);


if ($errormessage) {
    &Header::openbox('100%', 'left', $Lang::tr{'copfilter error messages'});
    print "<font class='base'>$errormessage&nbsp;</font>\n";
    print "&nbsp;</class>\n";
    &Header::closebox();
}


################################################################################
##  Website - Test / Debug
################################################################################

system ("perl -pe \'s\/(\\\d+\\\.\\\d+)\/localtime \$1\/e\' \/var\/log\/squid\/access.log > \/tmp\/squid_access.log");

print "<a name='test'/>";
&Header::openbox('100%', 'left', "$Lang::tr{'copfilter testdebug'}:");
print "<form method='post' action='/cgi-bin/copfilter_testlog.cgi' enctype='multipart/form-data'>";
print <<END


<table width='100%' border='0' cellpadding='5' cellspacing='3'>
<tr>
        <td nowrap width='60%'></td>
        <td nowrap width='10%'></td>
        <td nowrap width='30%'></td>
</tr>
<tr>
	<td nowrap><u><b>$Lang::tr{'copfilter testpop3'}</b></u></td>
</tr>
<tr>
	<td nowrap></td>
</tr>
<tr>	
	<td nowrap></td>
</tr>
<tr>
	<td nowrap valign='top'>$Lang::tr{'copfilter testpop3-2'}</td>
	<td nowrap valign='top'><input type='submit' name='ACTION' value='$Lang::tr{'copfilter send testvirus'}'/>
	<br><br>	<input type='submit' name='ACTION' value='$Lang::tr{'copfilter send testspam'}' /> 
	<br><br>	<input type='submit' name='ACTION' value='$Lang::tr{'copfilter send exe attachment'}' /></td>

</tr>
</table>

<br />
<br />
<br /><u><b>$Lang::tr{'copfilter mailtestresult'}</b></u><br /><br />
$Lang::tr{'copfilter mailtestresult2'}
<pre>
X-Filtered-With: Copfilter Version 2.0.91beta4 by Markus Madlener @ http://www.copfilter.org 
X-Copfilter-Filtered-With: P3Scan 2.3.2
X-Copfilter-Filtered-With: ProxSMTP 1.8
X-Copfilter-Filtered-With: SpamAssassin 3.3.2
X-Copfilter-Virus-Scanned: ClamAV 0.97.6 / 54 / 16516 / 210 / 40129
X-Copfilter-Virus-Scanned: AVG 13.0.3115 - Virus Database 2013-06-12 18:20
X-Copfilter-Virus-Scanned: F-PROT 6.7.10.6267 - Engine 4.6.5.141 - Virus Database 2013-01-17 14:55
X-Copfilter-Browsing-Scanned: ClamAV using safebrowsing.cvd - 2013-01-18 04:40
X-Copfilter-BL-URL-Scanned: ClamAV using blurl.ndb - 2013-01-18 09:20
X-Copfilter-Junk-Scanned: ClamAV using junk.ndb - 2013-01-17 18:20
X-Copfilter-Junk-URLBL-Scanned: ClamAV using jurlbl.ndb - 2013-01-18 09:20
X-Copfilter-Junk-URLBLA-Scanned: ClamAV using jurlbla.ndb - 2013-01-18 09:20
X-Copfilter-Lottery-Scanned: ClamAV using lott.ndb - 2012-12-22 00:32
X-Copfilter-Phishing-Scanned: ClamAV using phish.ndb - 2013-01-17 15:20
X-Copfilter-Rogue-Scanned: ClamAV using rogue.hdb - 2013-01-17 19:20
X-Copfilter-FileType-Scanned: ClamAV using sanesecurity.ftm - 2012-12-22 00:32
X-Copfilter-Scam-Scanned: ClamAV using scam.ndb - 2013-01-15 12:20
X-Copfilter-Spam-Scanned: ClamAV using spam.ldb - 2012-12-22 00:32
X-Copfilter-SPAM-Attachments-Scanned: ClamAV using spamattach.hdb - 2012-12-22 00:32
X-Copfilter-SpamImage-Scanned: ClamAV using spamimg.hdb - 2012-12-22 00:32
X-Copfilter-Spear-Scanned: ClamAV using spear.ndb - 2013-01-18 05:20
X-Copfilter-Spearlink-Scanned: ClamAV using spearl.ndb - 2013-01-18 05:20
X-Copfilter-Honeynet-Scanned: ClamAV using honeynet.hdb - 2012-02-15 14:29
X-Copfilter-SecuriteInfo-Scanned: ClamAV using securiteinfo.hdb - 2013-01-17 23:00
X-Copfilter-Batch-Scanned: ClamAV using securiteinfobat.hdb - 2012-08-21 10:16
X-Copfilter-DOS-Scanned: ClamAV using securiteinfodos.hdb - 2012-05-30 22:28
X-Copfilter-ELF-Scanned: ClamAV using securiteinfoelf.hdb - 2013-01-15 11:16
X-Copfilter-Office-Scanned: ClamAV using securiteinfooffice.hdb - 2013-01-15 11:49
X-Copfilter-PDF-Scanned: ClamAV using securiteinfopdf.hdb - 2012-08-16 11:12
X-Copfilter-Bash-Scanned: ClamAV using securiteinfosh.hdb - 2012-08-21 12:26
X-Copfilter-BCRACK-Scanned: ClamAV using bofhland_cracked_URL.ndb - 2013-01-18 09:20
X-Copfilter-BATTACH-Scanned: ClamAV using bofhland_malware_attach.hdb - 2013-01-16 14:25
X-Copfilter-BMAL-Scanned: ClamAV using bofhland_malware_URL.ndb - 2013-01-18 09:20
X-Copfilter-BPHISH-Scanned: ClamAV using bofhland_phishing_URL.ndb - 2013-01-18 02:20
X-Copfilter-LW-Image-Scanned: ClamAV using doppelstern.hdb - 2013-01-18 08:20
X-Copfilter-LW-Scam-Scanned: ClamAV using doppelstern.ndb - 2013-01-18 09:20
X-Copfilter-Winnow-Attachments-Scanned: ClamAV using winnow.attachments.hdb - 2013-01-17 20:20
X-Copfilter-Winnow-Bad-CW-Scanned: ClamAV using winnow_bad_cw.hdb - 2012-12-30 12:20
X-Copfilter-Winnow-Pattern-Scanned: ClamAV using winnow.complex.patterns.ldb - 2012-12-22 00:32
X-Copfilter-Winnow-Malware-Scanned: ClamAV using winnow_malware.hdb - 2013-01-18 09:20
X-Copfilter-Winnow-Phishing-Scanned: ClamAV using winnow_phish_complete.ndb - 2013-01-18 09:20
X-Copfilter-Winnow-Spam-Scanned: ClamAV using winnow_spam_complete.ndb - 2013-01-18 09:20
X-Copfilter-Scamlink-Scanned: ClamAV using scamnailer.ndb - 2013-01-18 07:20
X-Copfilter-Porcupine-Phishing-Scanned: ClamAV using phishtank.ndb - 2013-01-18 09:20
X-Copfilter-Porcupine-Malware-Scanned: ClamAV using porcupine.ndb - 2013-01-18 08:20
X-Copfilter-CRDF-Scanned: ClamAV using crdfam.clamav.hdb - 2013-01-14 15:20
X-Copfilter-Malware-Scanned: ClamAV using mbl.ndb - 2013-01-18 08:10
</pre>
<br />
<br />
<table width='100%' border='0' cellpadding='5' cellspacing='5'>
<tr>
	<td width='20%'></td>
	<td width='25%'></td>
	<td width='11%'></td>
	<td width='11%'></td>
	<td width='11%'></td>
	<td width='11%'></td>
	<td width='11%'></td>
</tr>
<tr>
    <td nowrap style="border-bottom:outset 2px;font-size:1.3em;"><b>$Lang::tr{'copfilter testhttp&ftp'}</b></td>
	<td nowrap></td>
END
;
if (  -e "${copfilter_swroot}/log/cron.privoxy_rules.log" ||  -e "${copfilter_swroot}/log/cronhourly.log" ||  
-e "${copfilter_swroot}/log/cron4hourly.log" ||  -e "${copfilter_swroot}/log/crondaily.log"
||  -e "${copfilter_swroot}/log/3pmodify.log" ||  -e "${copfilter_swroot}/log/copfiltercron.log"
||  -e "${copfilter_swroot}/log/saupdate.log" ){
print <<END
	    <td nowrap colspan='5' align='center' style="border-bottom:outset 2px;font-size:1.4em;letter-spacing:0.7em;"><b>$Lang::tr{'copfilter log'}</b></td>
END
;
}else{
print <<END
	    <td nowrap colspan='4' align='center' style="border-bottom:outset 2px;font-size:1.4em;letter-spacing:0.7em;"><b>$Lang::tr{'copfilter log'}</b></td>
END
;
}
print <<END
</tr>
<tr>
	<td nowrap><b>Download links</b></td>
	<td nowrap></td>
	<td nowrap><b>System</b></td>
	<td nowrap><b>AntiVirus</b></td>
	<td nowrap><b>Copfilter</b></td>
	<td nowrap><b>Email</b></td>
END
;
if (  -e "${copfilter_swroot}/log/cron.privoxy_rules.log" ||  -e "${copfilter_swroot}/log/cronhourly.log" ||  
-e "${copfilter_swroot}/log/cron4hourly.log" ||  -e "${copfilter_swroot}/log/crondaily.log"
||  -e "${copfilter_swroot}/log/3pmodify.log" ||  -e "${copfilter_swroot}/log/copfiltercron.log"
||  -e "${copfilter_swroot}/log/saupdate.log" ){
print <<END
	<td nowrap><b>Copfilter mods</b></td>
END
;}

print <<END
</tr>
    <td nowrap valign='top'> <a> $Lang::tr{'copfilter testvirus http'}</a>
     <br /><a href='http://www.testvirus.de/testvirus/eicar.com' target='_blank'>COM-Datei</a>
     <br /><a href='http://meineipadresse.de/testvirus/eicar.zip' target='_blank'>ZIP-Datei</a>
     <br /><a href='http://meineipadresse.de/testvirus/eicar2.zip' target='_blank'>ZIP(2)-Datei</a>
     <br /><a href='http://meineipadresse.de/testvirus/eicar3.zip' target='_blank'>ZIP(3)-Datei</a>
     <br /><a href='http://meineipadresse.de/testvirus/eicar4.zip' target='_blank'>ZIP(4)-Datei</a>
     <br /><a href='http://meineipadresse.de/testvirus/eicar.tar' target='_blank'>TAR-Datei</a>
     <br /><a href='http://meineipadresse.de/testvirus/eicar.com.gz' target='_blank'>GZ-Datei</a>
     <br /><a href='http://meineipadresse.de/testvirus/eicar.cab' target='_blank'>CAB-Datei</a>
    <br /><br /><a> $Lang::tr{'copfilter testvirus ftp'}</a>
     <br /><a href='ftp://ftp.kaspersky.com/utils/eicar/eicar.zip' target='_blank'>ZIP-Datei</a>
    <br /><a href='ftp://ftp.hogia.net/pub/jbdata/eicar.com' target='_blank'>COM-Datei</a></td>

	<td nowrap></td>

    <td nowrap valign='top'>
END
;
if (  -e "${copfilter_swroot}/log/httpd_access.log") {
print <<END
    	<a href='/copfilterlog/httpd_access.log' target='_blank'>httpd_access.log</a>
END
;}

if (  -e "${copfilter_swroot}/log/httpd_error.log") {
if (  -e "${copfilter_swroot}/log/httpd_access.log") {
print <<END
    <br /><a href='/copfilterlog/httpd_error.log' target='_blank'>httpd_error.log</a>
END
;}else{
print <<END
    <a href='/copfilterlog/httpd_error.log' target='_blank'>httpd_error.log</a>
END
;}}

if ( -e "${copfilter_swroot}/log/httpd_ssl_engine.log") {
if ( -e "${copfilter_swroot}/log/httpd_access.log" || -e "${copfilter_swroot}/log/httpd_error.log") {
print <<END
    <br /><a href='/copfilterlog/httpd_ssl_engine.log' target='_blank'>httpd_ssl_engine.log</a>
END
;}else{
print <<END
    <a href='/copfilterlog/httpd_ssl_engine.log' target='_blank'>httpd_ssl_engine.log</a>
END
;}}

if ( -e "${copfilter_swroot}/log/messages.log") {
if ( -e "${copfilter_swroot}/log/httpd_access.log" || -e "${copfilter_swroot}/log/httpd_error.log" ||
-e "${copfilter_swroot}/log/httpd_ssl_engine.log") {
print <<END
    <br /><a href='/copfilterlog/messages.log' target='_blank'>messages.log</a>
END
;}else{
print <<END
    <a href='/copfilterlog/messages.log' target='_blank'>messages.log</a>
END
;}}

if ( -e "${copfilter_swroot}/log/squid_access.log") {
if ( -e "${copfilter_swroot}/log/httpd_access.log" || -e "${copfilter_swroot}/log/httpd_error.log" ||
-e "${copfilter_swroot}/log/httpd_ssl_engine.log" || -e "${copfilter_swroot}/log/messages.log") {
print <<END
    <br /><a href='/copfilterlog/squid_access.log' target='_blank'>squid_access.log</a>
END
;}else{
print <<END
    <a href='/copfilterlog/squid_access.log' target='_blank'>squid_access.log</a>
END
;}}

if ( -e "${copfilter_swroot}/log/squid_cache.log") {
if ( -e "${copfilter_swroot}/log/httpd_access.log" || -e "${copfilter_swroot}/log/httpd_error.log" ||
-e "${copfilter_swroot}/log/httpd_ssl_engine.log" || -e "${copfilter_swroot}/log/messages.log" ||
-e "${copfilter_swroot}/log/squid_access.log") {
print <<END
    <br /><a href='/copfilterlog/squid_cache.log' target='_blank'>squid_cache.log</a>
END
;}else{
print <<END
    <a href='/copfilterlog/squid_cache.log' target='_blank'>squid_cache.log</a>
END
;}}

if ( -e "${copfilter_swroot}/log/squid_user_agent.log") {
if ( -e "${copfilter_swroot}/log/httpd_access.log" || -e "${copfilter_swroot}/log/httpd_error.log" ||
-e "${copfilter_swroot}/log/httpd_ssl_engine.log" || -e "${copfilter_swroot}/log/messages.log" ||
-e "${copfilter_swroot}/log/squid_access.log" || -e "${copfilter_swroot}/log/squid_cache.log") {
print <<END
    <br /><a href='/copfilterlog/squid_user_agent.log' target='_blank'>squid_user_agent.log</a>
END
;}else{
print <<END
    <a href='/copfilterlog/squid_user_agent.log' target='_blank'>squid_user_agent.log</a>
END
;}}

print <<END
  </td>
    <td nowrap valign='top'>
          <a href='/copfilterlog/clamd.log' target='_blank'>clamd.log</a>
    <br /><a href='/copfilterlog/freshclam.log' target='_blank'>freshclam.log</a>
END
;

if ( -e "${copfilter_swroot}/opt/f-prot/default/fpscand" ){
print <<END
	 <br /><a href='/copfilterlog/fpscand.log' target='_blank'>fpscand.log</a>
END
;
}
if ( -e "${copfilter_swroot}/opt/avg/default/bin/avgscan"){
print <<END
    <br /><a href='/copfilterlog/avgscan.log' target='_blank'>avgscan.log</a>
    <br /><a href='/copfilterlog/avgupd.log' target='_blank'>avgupd.log</a>
END
;
}
print <<END
  </td>
  <td nowrap valign='top'>
    	<a href='/copfilterlog/havp_access.log' target='_blank'>havp_access.log</a>
    <br /><a href='/copfilterlog/havp_error.log' target='_blank'>havp_error.log</a>
    <br /><a href='/copfilterlog/icap_server.log' target='_blank'>icap_server.log</a>
    <br /><a href='/copfilterlog/privoxy_logfile' target='_blank'>privoxy_logfile</a>
    <br /><a href='/copfilterlog/frox.log' target='_blank'>frox.log</a>
    <br /><a href='/copfilterlog/monit.log' target='_blank'>monit.log</a>
  </td>

  <td nowrap valign='top'>
    	<a href='/copfilterlog/p3scan.log' target='_blank'>p3scan.log</a>
    <br /><a href='/copfilterlog/proxsmtpd.log' target='_blank'>proxsmtpd.log</a>
    <br /><a href='/copfilterlog/spamd.log' target='_blank'>spamd.log</a>
    <br /><a href='/copfilterlog/razor-agent.log' target='_blank'>razor-agent.log</a>
    <br /><a href='/copfilterlog/renattach.log' target='_blank'>renattach.log</a>
  </td>

  <td nowrap valign='top'>
END
;
if ( -e "${copfilter_swroot}/log/copfiltercron.log") {
print <<END
    	<a href='/copfilterlog/copfiltercron.log' target='_blank'>copfiltercron.log</a>
END
;}
if ( -e "${copfilter_swroot}/log/crondaily.log") {
if ( -e "${copfilter_swroot}/log/copfiltercron.log" ) {
print <<END
    <br /><a href='/copfilterlog/crondaily.log' target='_blank'>crondaily.log</a>
END
;
}else{
print <<END
    <a href='/copfilterlog/crondaily.log' target='_blank'>crondaily.log</a>
END
;}}   

if ( -e "${copfilter_swroot}/log/cron4hourly.log") {
if ( -e "${copfilter_swroot}/log/copfiltercron.log" ||  -e "${copfilter_swroot}/log/crondaily.log") {
print <<END
 <br /><a href='/copfilterlog/cron4hourly.log' target='_blank'>cron4hourly.log</a>
END
;
}else{
print <<END
	<a href='/copfilterlog/cron4hourly.log' target='_blank'>cron4hourly.log</a>
END
;}}

if ( -e "${copfilter_swroot}/log/cronhourly.log") {
if ( -e "${copfilter_swroot}/log/copfiltercron.log" ||  -e "${copfilter_swroot}/log/crondaily.log" ||
 -e "${copfilter_swroot}/log/cron4hourly.log") {
print <<END
    <br /><a href='/copfilterlog/cronhourly.log' target='_blank'>cronhourly.log</a>
END
;
}else{
print <<END
    <a href='/copfilterlog/cronhourly.log' target='_blank'>cronhourly.log</a>
END
;}}


if ( -e "${copfilter_swroot}/log/3pmodify.log") {
if ( -e "${copfilter_swroot}/log/copfiltercron.log" ||  -e "${copfilter_swroot}/log/crondaily.log" ||
 -e "${copfilter_swroot}/log/cron4hourly.log" || -e "${copfilter_swroot}/log/cronhourly.log") {
print <<END
    <br /><a href='/copfilterlog/3pmodify.log' target='_blank'>3pmodify.log</a>
END
;
}else{
print <<END
    <a href='/copfilterlog/3pmodify.log' target='_blank'>3pmodify.log</a>
END
;}}

#END
#;
#}

if ( -e "${copfilter_swroot}/log/cron.privoxy_rules.log") {
if ( -e "${copfilter_swroot}/log/copfiltercron.log" ||  -e "${copfilter_swroot}/log/crondaily.log" ||
 -e "${copfilter_swroot}/log/cron4hourly.log" || -e "${copfilter_swroot}/log/cronhourly.log" ||
 -e "${copfilter_swroot}/log/3pmodify.log") {
print <<END
      <br /><a href='/copfilterlog/cron.privoxy_rules.log' target='_blank'>privoxy_rules.log</a>
END
;
}else{
print <<END
      <a href='/copfilterlog/cron.privoxy_rules.log' target='_blank'>privoxy_rules.log</a>
END
;}}


if ( -e "${copfilter_swroot}/log/saupdate.log") {
if ( -e "${copfilter_swroot}/log/copfiltercron.log" ||  -e "${copfilter_swroot}/log/crondaily.log" ||
 -e "${copfilter_swroot}/log/cron4hourly.log" || -e "${copfilter_swroot}/log/cronhourly.log" ||
 -e "${copfilter_swroot}/log/3pmodify.log" || -e "${copfilter_swroot}/log/cron.privoxy_rules.log") {
print <<END
      <br /><a href='/copfilterlog/saupdate.log' target='_blank'>saupdate.log</a>
END
;
}else{
print <<END
      <a href='/copfilterlog/saupdate.log' target='_blank'>saupdate.log</a>
END
;}}


if ( -e "${copfilter_swroot}/log/restore.log") {
if ( -e "${copfilter_swroot}/log/copfiltercron.log" ||  -e "${copfilter_swroot}/log/crondaily.log" ||
 -e "${copfilter_swroot}/log/cron4hourly.log" || -e "${copfilter_swroot}/log/cronhourly.log" ||
 -e "${copfilter_swroot}/log/3pmodify.log" || -e "${copfilter_swroot}/log/cron.privoxy_rules.log" ||
 -e "${copfilter_swroot}/log/saupdate.log") {
print <<END
      <br /><a href='/copfilterlog/restore.log' target='_blank'>restore.log</a>
END
;
}else{
print <<END
      <a href='/copfilterlog/restore.log' target='_blank'>restore.log</a>
END
;}}



print <<END
  </td>
</tr>
</table>




<br />
<br />

<!--
<table border='0'>
<tr>
        <td nowrap><input type='submit' name='ACTION' value='Start p3scan debugging' /></td> 
        <td nowrap> &nbsp; &nbsp; <input type='submit' name='ACTION' value='$Lang::tr{'copfilter start proxsmtpd debug'}' /></td>
        <td nowrap> &nbsp; &nbsp; <input type='submit' name='ACTION' value='$Lang::tr{'copfilter make all tests'}' /> </td>
        <td nowrap> &nbsp; &nbsp; $Lang::tr{'copfilter make_test1'}</td>
        <td nowrap></td>
</tr>
</table>
<br />
<b>$Lang::tr{'copfilter make_test2'}</b>
-->

<br />



<table width='100%' border='1' cellpadding='5'>
<tr>
END
;

if ( $copfiltersettings{'RETRIEVE_LATEST_VERSION'} eq 'on' ) {

my $return = &downloadver();
my @latest2 = split(/;x;/,$return);
my @latest = split(/LATEST-VERSION-IS/,$latest2[1]);
$copfiltersettings{'LATESTVERSION'} = $latest[1];

#if ( $copfiltersettings{'LATESTVERSION'} == $copfiltersettings{'VERSION'} ) {
  print "<td nowrap width='25%' align='center'>$Lang::tr{'copfilter latestversion'}: \n";
  print "<font color='#339933'>";
  print "<b><br />";
  print $copfiltersettings{'LATESTVERSION'};
  print "</b>";
  print "</font>";
#}
#else
#{
#  print "<font color='#993333'>";
#  print $copfiltersettings{'LATESTVERSION'};
#  print "</font>";
#
#}
print <<END
	<br />$Lang::tr{'copfilter latestbetaversion'}: 
END
;
#my $return = &downloadver();
my @latestbeta = split(/LATEST-BETA-VERSION-IS/,$return);
$copfiltersettings{'LATESTBETAVERSION'} = $latestbeta[1];
# Get installed version
my $installedversion;
my @installedversion;

#if ( $copfiltersettings{'LATESTBETAVERSION'} == $copfiltersettings{'VERSION'} ) {
#  print "<font color='#339933'>";
  print "<font color='#993333'>";
  print "<b><br />";
  print $copfiltersettings{'LATESTBETAVERSION'};
  print "</b>";
  print "</font>";
#}
#else
#{
#  print "<font color='#993333'>";
#  print $copfiltersettings{'LATESTBETAVERSION'};
#  print "</font>";
#
#}

}

print <<END
<!--        <br /> $Lang::tr{'copfilter update green'}
        <br /> $Lang::tr{'copfilter update red'} -->
        </td>
        <td nowrap  width='30%' align='center'><b><font color='#000000'>$Lang::tr{'copfilter installedversion'}</font><br /><font color='#2229B5'>$copfiltersettings{'VERSION'}</font></b><br />$Lang::tr{'copfilter forum'}
            <a href='http://www.copfilter.org/forum' target='_blank'>http://www.copfilter.org/forum</a></td>
        <td nowrap width='25%' align='center'>$Lang::tr{'copfilter latestversion2'}
            <a href='http://www.copfilter.org' target='_blank'>http://www.copfilter.org</a> </td>
        <td nowrap width='20%' align='center'>$Lang::tr{'copfilter mailing list1'}<br />
                        <a href='https://lists.sourceforge.net/lists/listinfo/copfilter-main'  target='_blank'>$Lang::tr{'copfilter mailing list2'}</a>
                        <br /><a href='http://sourceforge.net/mailarchive/forum.php?forum_name=copfilter-main' target='_blank'>$Lang::tr{'copfilter mailing list3'}</a></td>
</tr>
</table>
END
;

print "</form>\n";

&Header::closebox();


# For Testing
#print "<pre>";
#$output = `cat /var/log/copfilter/default/etc/global_settings`;
#print "$output\n";
#print "</pre>";
&Header::closebigbox();

&Header::closepage();


}
